.ig
This file is part of groff, the GNU roff type-setting system.

Copyright (C) 2002, 2003, 2005, 2008, 2009
  Free Software Foundation, Inc.
written by Werner Lemberg <wl@gnu.org>

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.3 or
any later version published by the Free Software Foundation; with the
Invariant Sections being this .ig-section and AUTHORS, with no
Front-Cover Texts, and with no Back-Cover Texts.

A copy of the Free Documentation License is included as a file called
FDL in the main directory of the groff source package.
..
.
.do nr groff_mom_C \n[.C]
.cp 0
.
.de TQ
.br
.ns
.TP \\$1
..
.
.TH GROFF_MOM @MAN7EXT@ "@MDATE@" "Groff Version @VERSION@"
.
.
.SH NAME
.
groff_mom \- groff `mom' macros
.
.
.SH SYNOPSIS
.
.B groff
.B \-mom
[
.IR files .\|.\|.\&
]
.br
.B groff
.B \-m\ mom
[
.IR files .\|.\|.\&
]
.
.
.SH DESCRIPTION
.
.B mom
(\[lq]my own macros\[rq], \[lq]my other macros\[rq], \[lq]maximum
overdrive macros\[rq], .\|.\|.\&) is a macro set for groff, designed
primarily to format documents for PostScript output.
.PP
.B mom
provides two categories of macros: macros for typesetting and macros
for document processing.
The typesetting macros provide access to groff's typesetting power in
ways that are simpler to master and to use than groff's primitives.
The document processing macros provide customizable markup
\[lq]tags\[rq] that allow the user to design and output
professional-looking documents with a minimum of typesetting
intervention.
.PP
mom comes with her own (very) complete documentation in HTML format.
.
.SH FILES
.TP
.B om.tmac
\[en] the main macro file
.TQ
.B mom.tmac
\[en] a wrapper file that calls om.tmac directly.
.
.TP
.UR @HTMLDOCDIR@/\:momdoc/\:toc.html
@HTMLDOCDIR@/\:momdoc/\:toc.html
.UE
\[en] entry point to the HTML documentation
.
.TP
.B @EXAMPLEDIR@/*.mom
\[en] example files using mom
.
.
.SH AUTHOR
.
.B mom
was written by
.MT peter@schaffter.ca
Peter Schaffter
.ME .
Please send bug reports to the
.MT bug-groff@gnu.org
groff bug mailing list
.ME
or directly to the author at the address, above.
.
.cp \n[groff_mom_C]
.
.\" Local Variables:
.\" mode: nroff
.\" End:
